//=============================================================================
//                        LibOrderReliable_V1_1_2.mqh
//
//                      Copyright  2006, Matthew Kennel 
//                            mbkennelfx@gmail.com
//
//
//  Header File for library: LibOrderRelaible_V1_1_2.mq4
//=============================================================================
#property copyright "Copyright  2006, Matt Kennell"
#property link      "no site"

#import "LibOrderReliable_V1_1_2.ex4"


int  OrderSendReliable(string symbol, int cmd, double volume, double price,
					   int slippage, double stoploss, double takeprofit,
					   string comment, int magic, datetime expiration = 0, 
					   color arrow_color = CLR_NONE);

int  OrderSendReliableMKT(string symbol, int cmd, double volume, double price,
						  int slippage, double stoploss, double takeprofit,
						  string comment, int magic, datetime expiration = 0, 
						  color arrow_color = CLR_NONE);
					  
bool OrderModifyReliable(int ticket, double price, double stoploss, 
						 double takeprofit, datetime expiration, 
						 color arrow_color = CLR_NONE);

bool OrderModifyReliableSymbol(string symbol, int ticket, double price, 
							   double stoploss, double takeprofit, 
							   datetime expiration, color arrow_color = CLR_NONE);

bool OrderCloseReliable(int ticket, double lots, double price, 
						int slippage, color arrow_color = CLR_NONE);

bool OrderDeleteReliable(int ticket);

int 	OrderReliableLastErr();
string 	OrderReliableErrTxt(int err);
void 	OrderReliablePrint(string s);
string 	OrderReliable_CommandString(int cmd);
void 	OrderReliable_EnsureValidStop(string symbol, double price, double& sl);
void 	OrderReliable_SleepRandomTime(double mean_time, double max_time);



